import org.jetbrains.kotlin.gradle.tasks.KotlinCompile

plugins {
    application
    kotlin("jvm") version "1.4.0"
}
group = "nl.voidcorp.ottobot"
version = "1.0-SNAPSHOT"

repositories {
    jcenter()
}

fun DependencyHandlerScope.exposed(part: String) = implementation("org.jetbrains.exposed", part, "0.27.1")


dependencies {
    implementation("net.dv8tion:JDA:4.2.0_200") {
        exclude(module = "opus-java")
    }
    implementation("io.ktor:ktor-client-apache:1.4.0")
    implementation("io.ktor:ktor-client-jackson:1.4.0")

    implementation("ch.qos.logback:logback-classic:1.2.3")
    exposed("exposed-core")
    exposed("exposed-dao")
    exposed("exposed-jdbc")
    implementation("org.xerial:sqlite-jdbc:3.30.1")
    implementation("com.impossibl.pgjdbc-ng:pgjdbc-ng:0.8.3")
    implementation(kotlin("reflect"))
}

tasks.withType<KotlinCompile>() {
    kotlinOptions.jvmTarget = "13"
}

tasks {
    distTar {
        archiveFileName.set("ottobot.tar")
    }
}

application {
    applicationName = "ottobot"
    mainClassName = "nl.voidcorp.ottobot.MainKt"
}