package nl.voidcorp.ottobot.database

import org.jetbrains.exposed.dao.id.IntIdTable
import org.jetbrains.exposed.dao.id.LongIdTable

object GuildStores : LongIdTable("guild_store") {
    var defaultVerified = bool("default_verified").default(false)
    var guildId = long("guild_id")
    var prefix = varchar("prefix", 255).default("?")
}

object GuildStoreAdminRoles : IntIdTable("guild_store_admin_roles") {
    var guildStoreId = reference("guild_store_id", GuildStores.id)
    var adminRoles = long("admin_roles")
}

object GuildStoreBotChannels : IntIdTable("guild_store_bot_channels") {
    var guildStoreId = reference("guild_store_id", GuildStores.id)
    var botChannels = long("bot_channels")
}

object GuildStoreModeratorRoles : IntIdTable("guild_store_moderator_roles") {
    var guildStoreId = reference("guild_store_id", GuildStores.id)
    var moderatorRoles = long("moderator_roles")
}

object GuildStoreRoleMap : IntIdTable("guild_store_role_map") {
    var guildStoreId = reference("guild_store_id", GuildStores.id)
    var roleMap = long("role_map")
    var roleMapKey = varchar("role_map_key", 255)
}